<?php

use QUI\ERP\CRM\TaskStatus\Handler;
use QUI\Utils\Security\Orthos;

/**
 * Update a processing status
 *
 * @param int $id - ProcessingStatus ID
 * @param string $color - hex color code
 * @param array $title - (multilingual) title
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_crm_ajax_backend_taskStatus_update',
    function ($id, $color, $title) {
        $id      = (int)$id;
        $Handler = Handler::getInstance();

        $Handler->updateTaskStatus(
            $id,
            Orthos::clear($color),
            Orthos::clearArray(\json_decode($title, true))
        );
    },
    ['id', 'color', 'title'],
    'Permission::checkAdminUser'
);
