<?php

/**
 * This file contains package_quiqqer_crm_ajax_backend_tasks_grid_search
 */

/**
 * search
 *
 * @param string $search
 * @return integer
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_crm_ajax_backend_tasks_grid_search',
    function ($search, $options, $filter) {
        $options = \json_decode($options, true);
        $filter  = \json_decode($filter, true);
        $page    = 1;
        $perPage = 20;

        if (isset($options['page'])) {
            $page = (int)$options['page'];
        }

        if (isset($options['perPage'])) {
            $perPage = (int)$options['perPage'];
        }

        // search
        $limitStart = (int)($page * $perPage) - $perPage;

        $Search = new \QUI\ERP\CRM\TaskSearch();
        $Search->setLimit($limitStart, $perPage);

        if (isset($options['issuable'])) {
            if ($options['issuable']) {
                $Search->onlyIssuable();
            } else {
                $Search->resetOnlyIssuable();
            }
        }

        foreach ($filter as $f => $v) {
            $Search->setFilter($f, $v[0], $v[1]);
        }

        $tasks = $Search->search($search);

        // grid helper
        $Grid = new QUI\Utils\Grid();
        $Grid->setAttribute('page', $page);
        $Grid->setAttribute('perPage', $perPage);


        return $Grid->parseResult(
            QUI\ERP\CRM\Utils::parseTasksForGrid($tasks),
            $Search->count()
        );
    },
    ['search', 'options', 'filter'],
    'Permission::checkAdminUser'
);
