/**
 * @module package/quiqqer/crm/bin/backend/controls/settings/TaskStatusSelect
 * @author www.pcsg.de (Henning Leutz)
 */
define('package/quiqqer/crm/bin/backend/controls/settings/TaskStatusSelect', [

    'qui/QUI',
    'qui/controls/Control',
    'qui/controls/buttons/Select',
    'Ajax'

], function (QUI, QUIControl, QUISelect, QUIAjax) {
    "use strict";

    var lg = 'quiqqer/crm';

    return new Class({

        Extends: QUIControl,
        Type   : 'package/quiqqer/crm/bin/backend/controls/settings/TaskStatusSelect',

        Binds: [
            '$onImport'
        ],

        initialize: function (options) {
            this.parent(options);

            this.addEvents({
                onImport: this.$onImport
            });
        },

        /**
         * event: on import
         */
        $onImport: function () {
            var self = this;

            this.$Input = this.getElm();
            this.$Elm   = new Element('div', {
                'class': 'field-container-field field-container-field-no-padding'
            }).wraps(this.$Input);

            this.$Select = new QUISelect({
                showIcons: false,
                events   : {
                    onChange: function (value) {
                        self.$Input.value = value;
                    }
                }
            });

            this.$Select.inject(this.$Elm);
            this.$Select.disable();

            this.$Select.setStyles({
                border: 0,
                width : '100%'
            });

            QUIAjax.get('package_quiqqer_crm_ajax_backend_taskStatus_list', function (list) {
                var data = list.data;

                for (var i = 0, len = data.length; i < len; i++) {
                    self.$Select.appendChild(
                        data[i].title,
                        data[i].id
                    );
                }

                self.$Select.enable();
                self.$Select.setValue(self.$Input.value);
            }, {
                'package': 'quiqqer/crm'
            });
        }
    });
});
