<?php

namespace QUI\ERP\CRM;

use QUI;

/**
 * Class Utils
 *
 * @package QUI\ERP\CRM
 */
class Utils
{
    /**
     * @param array $tasks
     * @return array
     */
    public static function parseTasksForGrid($tasks = [])
    {
        $now   = time();
        $Users = QUI::getUsers();

        // task status
        $list       = TaskStatus\Handler::getInstance()->getTaskStatusList();
        $statusList = [];

        foreach ($list as $Status) {
            $statusList[$Status->getId()] = $Status;
        }


        foreach ($tasks as $key => $task) {
            $tasks[$key]['time'] = time();

            $from = $task['from'];
            $to   = $task['to'];

            if ($from && $from >= $now
                || $to && $to <= $now) {
                $tasks[$key]['issuable'] = 1;
            } else {
                $tasks[$key]['issuable'] = 0;
            }

            // status
            if (empty($tasks[$key]['status'])) {
                $tasks[$key]['status'] = 1;
            }

            $status = $tasks[$key]['status'];

            $tasks[$key]['statusDisplay'] = '<span class="quiqqer-crm-create-task-list-status">---</span>';

            if (isset($statusList[$status])) {
                /* @var $Status QUI\ERP\Accounting\Invoice\ProcessingStatus\Status */
                $Status = $statusList[$status];
                $color  = $Status->getColor();

                $tasks[$key]['statusDisplay'] = '<span class="quiqqer-crm-create-task-list-status" style="color: '.$color.'">'.
                                                $Status->getTitle().
                                                '</span>';
            }

            //user
            try {
                $tasks[$key]['customerDisplay'] = $Users->get($tasks[$key]['userId'])->getName();
            } catch (QUI\Exception $Exception) {
                $tasks[$key]['customerDisplay'] = '---';
            }
        }

        return $tasks;
    }
}
